
class ChainIterator implements java.util.Iterator
{
  private java.util.Iterator first;
  private java.util.Iterator second;

  public ChainIterator(java.util.Iterator i1, java.util.Iterator i2)
  {
    first = i1;
    second = i2;
  }

  public boolean hasNext()
  {
    if (first.hasNext())
      return true;
    else if (second.hasNext())
      return true;
    else
      return false;
  }

  public Object next()
    throws java.util.NoSuchElementException
  {
    if (first.hasNext())
      return first.next();
    else if (second.hasNext())
      return second.next();
    else
      throw new java.util.NoSuchElementException();
  }

  public void remove()
    throws java.lang.UnsupportedOperationException
  {
    throw new java.lang.UnsupportedOperationException();
  }

}
